%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name nspr
%global mingw_build_win32 1
%global mingw_build_win64 1

Summary:        Netscape Portable Runtime
Name:           mingw-nspr
Version:        4.8.8
Release:        1%{?dist}
License:        MPLv1.1 or GPLv2+ or LGPLv2+
URL:            http://www.mozilla.org/projects/nspr/
Group:          System Environment/Libraries
BuildRoot:      %{_tmppath}/%{name}-%{version}-root
BuildArch:      noarch

# Sources available at ftp://ftp.mozilla.org/pub/mozilla.org/nspr/releases/
# When CVS tag based snapshots are being used, refer to CVS documentation on
# mozilla.org and check out subdirectory mozilla/nsprpub.
Source0:        %{mingw_pkg_name}-%{version}.tar.gz
Source1:        nspr.pc.in
Source2:        nspr-config-vars.in

Patch1:         nspr-config-pc.patch
Patch2:         nspr-4.8.6-build.patch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  pkgconfig

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
NSPR provides platform independence for non-GUI operating system 
facilities. These facilities include threads, thread synchronization, 
normal file and network I/O, interval timing and calendar time, basic 
memory management (malloc and free) and shared library linking.

%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw32-%{mingw_pkg_name}
NSPR provides platform independence for non-GUI operating system 
facilities. These facilities include threads, thread synchronization, 
normal file and network I/O, interval timing and calendar time, basic 
memory management (malloc and free) and shared library linking.

%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw64-%{mingw_pkg_name}
NSPR provides platform independence for non-GUI operating system 
facilities. These facilities include threads, thread synchronization, 
normal file and network I/O, interval timing and calendar time, basic 
memory management (malloc and free) and shared library linking.

%prep

%setup -q -n nspr-%{version}

# Original nspr-config is not suitable for our distribution,
# because on different platforms it contains different dynamic content.
# Therefore we produce an adjusted copy of nspr-config that will be 
# identical on all platforms.
# However, we need to use original nspr-config to produce some variables
# that go into nspr.pc for pkg-config.

cp ./mozilla/nsprpub/config/nspr-config.in ./mozilla/nsprpub/config/nspr-config-pc.in
%patch1 -p0
pushd mozilla/nsprpub
%patch2 -p0
popd

cp %{SOURCE2} ./mozilla/nsprpub/config/

%build

%{mingw_set_suffix}
mkdir build_win32$suffix
pushd build_win32$suffix
%{mingw32_env} ; ../mozilla/nsprpub/configure \
                 --host=%{mingw32_host} \
                 --build=%_build \
                 --target=%{mingw32_target} \
                 --prefix=%{mingw32_prefix} \
                 --libdir=%{mingw32_libdir} \
                 --includedir=%{mingw32_includedir}/nspr4 \
%ifarch x86_64 ppc64 ia64 s390x sparc64
                 --enable-64bit \
%endif
                 --enable-optimize="%{mingw32_cflags}" \
                 --enable-win32-target=WINNT \
                 --enable-64bit=no \
                 --disable-debug
popd
mkdir build_win64$suffix
pushd build_win64$suffix
%{mingw64_env} ; ../mozilla/nsprpub/configure \
                 --host=%{mingw64_host} \
                 --build=%_build \
                 --target=%{mingw64_target} \
                 --prefix=%{mingw64_prefix} \
                 --libdir=%{mingw64_libdir} \
                 --includedir=%{mingw64_includedir}/nspr4 \
%ifarch x86_64 ppc64 ia64 s390x sparc64
                 --enable-64bit \
%endif
                 --enable-optimize="%{mingw64_cflags}" \
                 --enable-win32-target=WINNT \
                 --enable-64bit=yes \
                 --disable-debug
popd

# NSPR comes with its own "special" install program called nsinstall.
# This must be built as a native program.
pushd build_win32$suffix
%{mingw32_env} ; make -C config CC=gcc CFLAGS='-DXP_UNIX=1'
rm config/now.o
%{mingw32_env} ; make NSINSTALL=$(pwd)/config/nsinstall RANLIB="%{mingw32_ranlib}" OS_ARCH=WINNT %{?_smp_mflags}
popd
pushd build_win64$suffix
%{mingw64_env} ; make -C config CC=gcc CFLAGS='-DXP_UNIX=1'
rm config/now.o
%{mingw64_env} ; make NSINSTALL=$(pwd)/config/nsinstall RANLIB="%{mingw64_ranlib}" OS_ARCH=WINNT %{?_smp_mflags}
popd


%install
rm -rf $RPM_BUILD_ROOT

pushd build_win32$suffix
NSPR_LIBS=`./config/nspr-config --libs`
NSPR_CFLAGS=`./config/nspr-config --cflags`
NSPR_VERSION=`./config/nspr-config --version`
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw32_libdir}/pkgconfig
cat ./config/nspr-config-vars > $RPM_BUILD_ROOT/%{mingw32_libdir}/pkgconfig/nspr.pc
cat %{SOURCE1} | sed -e "s,%%libdir%%,%{mingw32_libdir},g" \
                     -e "s,%%prefix%%,%{mingw32_prefix},g" \
                     -e "s,%%exec_prefix%%,%{mingw32_prefix},g" \
                     -e "s,%%includedir%%,%{mingw32_includedir}/nspr4,g" \
                     -e "s,%%NSPR_VERSION%%,$NSPR_VERSION,g" \
                     -e "s,%%FULL_NSPR_LIBS%%,$NSPR_LIBS,g" \
                     -e "s,%%FULL_NSPR_CFLAGS%%,$NSPR_CFLAGS,g" >> \
                     $RPM_BUILD_ROOT/%{mingw32_libdir}/pkgconfig/nspr.pc
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw32_bindir}
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw32_lib}
%{__cp} ./config/nspr-config-pc $RPM_BUILD_ROOT/%{mingw32_bindir}/nspr-config
popd

pushd build_win64$suffix
NSPR_LIBS=`./config/nspr-config --libs`
NSPR_CFLAGS=`./config/nspr-config --cflags`
NSPR_VERSION=`./config/nspr-config --version`
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw64_libdir}/pkgconfig
cat ./config/nspr-config-vars > $RPM_BUILD_ROOT/%{mingw64_libdir}/pkgconfig/nspr.pc
cat %{SOURCE1} | sed -e "s,%%libdir%%,%{mingw64_libdir},g" \
                     -e "s,%%prefix%%,%{mingw64_prefix},g" \
                     -e "s,%%exec_prefix%%,%{mingw64_prefix},g" \
                     -e "s,%%includedir%%,%{mingw64_includedir}/nspr4,g" \
                     -e "s,%%NSPR_VERSION%%,$NSPR_VERSION,g" \
                     -e "s,%%FULL_NSPR_LIBS%%,$NSPR_LIBS,g" \
                     -e "s,%%FULL_NSPR_CFLAGS%%,$NSPR_CFLAGS,g" >> \
                     $RPM_BUILD_ROOT/%{mingw64_libdir}/pkgconfig/nspr.pc
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw64_bindir}
%{__mkdir_p} $RPM_BUILD_ROOT/%{mingw64_lib}
%{__cp} ./config/nspr-config-pc $RPM_BUILD_ROOT/%{mingw64_bindir}/nspr-config
popd

pushd build_win32$suffix
# 'make install' doesn't appear to work, so do it by hand.
mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
mkdir -p $RPM_BUILD_ROOT%{mingw32_libdir}/pkgconfig
mkdir -p $RPM_BUILD_ROOT%{mingw32_includedir}/nspr4
install dist/bin/*.dll $RPM_BUILD_ROOT%{mingw32_bindir}
install config/nspr-config $RPM_BUILD_ROOT%{mingw32_bindir}
install dist/lib/*.dll.a $RPM_BUILD_ROOT%{mingw32_libdir}
cp -rL dist/include/nspr/* $RPM_BUILD_ROOT%{mingw32_includedir}/nspr4/
popd

pushd build_win64$suffix
# 'make install' doesn't appear to work, so do it by hand.
mkdir -p $RPM_BUILD_ROOT%{mingw64_bindir}
mkdir -p $RPM_BUILD_ROOT%{mingw64_libdir}/pkgconfig
mkdir -p $RPM_BUILD_ROOT%{mingw64_includedir}/nspr4
install dist/bin/*.dll $RPM_BUILD_ROOT%{mingw64_bindir}
install config/nspr-config $RPM_BUILD_ROOT%{mingw64_bindir}
install dist/lib/*.dll.a $RPM_BUILD_ROOT%{mingw64_libdir}
cp -rL dist/include/nspr/* $RPM_BUILD_ROOT%{mingw64_includedir}/nspr4/
popd

%clean
rm -Rf $RPM_BUILD_ROOT

%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw32_bindir}/libnspr4.dll
%{mingw32_bindir}/libplc4.dll
%{mingw32_bindir}/libplds4.dll
%{mingw32_libdir}/libnspr4.dll.a
%{mingw32_libdir}/libplc4.dll.a
%{mingw32_libdir}/libplds4.dll.a
%{mingw32_libdir}/pkgconfig/nspr.pc
%{mingw32_includedir}/nspr4
%{mingw32_bindir}/nspr-config

%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw64_bindir}/libnspr4.dll
%{mingw64_bindir}/libplc4.dll
%{mingw64_bindir}/libplds4.dll
%{mingw64_libdir}/libnspr4.dll.a
%{mingw64_libdir}/libplc4.dll.a
%{mingw64_libdir}/libplds4.dll.a
%{mingw64_libdir}/pkgconfig/nspr.pc
%{mingw64_includedir}/nspr4
%{mingw64_bindir}/nspr-config

%changelog
* Mon Jun 27 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.33-1
- Updated to compile with mingw64.
- Based on Fedora and OpenSUSE mingw project packages.
